<?php

namespace Modules\Sc\Http\Controllers;

use Illuminate\Contracts\Support\Renderable;
use Illuminate\Http\Request;
use Illuminate\Routing\Controller;
use Modules\Sc\Entities\DocumentNumber;
use Modules\Sc\Entities\ProductHistorySetoff;

class ProductHistorySetOffController extends Controller
{

    public function saveGoodsReceived($product_history)
    {

        $prefix = $this->getPrefix($product_history->document_no);

        $setoff = new ProductHistorySetoff();
        $setoff->document_no = $product_history->document_no;
        $setoff->internal_id = $product_history->internal_id;
        $setoff->external_id = $prefix . "" . $product_history->external_id;
        $setoff->ref_internal_id = $product_history->internal_id;
        $setoff->ref_external_id = $product_history->external_id;
        $setoff->ref_document_no = $product_history->document_no;
        $setoff->quantity = $product_history->quantity;
        $setoff->setoff_quantity = 0;
        $setoff->cost_price = 0;
        $setoff->grn_internal_id = $product_history->internal_id;
        $setoff->grn_external_id = $product_history->external_id;
        $setoff->product_history_transaction_id = $product_history->transaction_id;
        $setoff->product_id = $product_history->product_id;
        $setoff->store_id = $product_history->store_id;
        $setoff->user_id = $product_history->user_id;
        $setoff->save();
    }




    public function saveGoodsTransferFromStore($product_history, $from_store)
    {

        $prefix = $this->getPrefix($product_history->document_no);

        $setoff_from = new ProductHistorySetoff();
        $setoff_from->document_no = $product_history->document_no;
        $setoff_from->internal_id = $product_history->internal_id;
        $setoff_from->external_id = $prefix . "" . $product_history->external_id;
        $setoff_from->ref_internal_id = $product_history->internal_id;
        $setoff_from->ref_external_id = $product_history->external_id;
        $setoff_from->ref_document_no = $product_history->document_no;
        $setoff_from->quantity = $product_history->quantity;
        $setoff_from->setoff_quantity = 0;
        $setoff_from->cost_price = 0;
        $setoff_from->grn_internal_id = $product_history->internal_id;
        $setoff_from->grn_external_id = $product_history->external_id;
        $setoff_from->product_history_transaction_id = $product_history->transaction_id;
        $setoff_from->product_id = $product_history->product_id;
        $setoff_from->store_id = $from_store;
        $setoff_from->user_id = $product_history->user_id;
        if ($setoff_from->save()) {
            $this->setoffGoodsTransfer($setoff_from);
        }
    }


    public function saveGoodsTransferToStore($product_history, $to_store)
    {

        $prefix = $this->getPrefix($product_history->document_no);

        $setoff_from = new ProductHistorySetoff();
        $setoff_from->document_no = $product_history->document_no;
        $setoff_from->internal_id = $product_history->internal_id;
        $setoff_from->external_id = $prefix . "" . $product_history->external_id;
        $setoff_from->ref_internal_id = $product_history->internal_id;
        $setoff_from->ref_external_id = $product_history->external_id;
        $setoff_from->ref_document_no = $product_history->document_no;
        $setoff_from->quantity = $product_history->quantity;
        $setoff_from->setoff_quantity = 0;
        $setoff_from->cost_price = 0;
        $setoff_from->grn_internal_id = $product_history->internal_id;
        $setoff_from->grn_external_id = $product_history->external_id;
        $setoff_from->product_history_transaction_id = $product_history->transaction_id;
        $setoff_from->product_id = $product_history->product_id;
        $setoff_from->store_id = $to_store;
        $setoff_from->user_id = $product_history->user_id;
        $setoff_from->save();
    }



    private function setoffGoodsTransfer($setoff_from)
    {
        $product_history_grn_setoff = ProductHistorySetoff::where([['product_id', '=', $setoff_from->product_id], ['store_id', '=', $setoff_from->store_id], ['document_no', '=', '100']])->get();
        $request_quantity = 0;
        foreach ($product_history_grn_setoff as $grn_setoff) {

            $available_quantity = $grn_setoff->quantity - $grn_setoff->setoff_quantity;
            if ($available_quantity > 0 && $request_quantity == 0) {

                $setoff_quantity = ($available_quantity - abs($setoff_from->quantity));
                if ($setoff_quantity > 0) {
                    $this->setoff($grn_setoff->transaction_id, $setoff_from->transaction_id, $setoff_from->quantity);
                    break;
                } else {
                    $this->setoff($grn_setoff->transaction_id, $setoff_from->transaction_id, $available_quantity);
                    $request_quantity = (abs($setoff_from->quantity) -  abs($available_quantity));
                }
            } else {
                $this->setoff($grn_setoff->transaction_id, $setoff_from->transaction_id, $request_quantity);
                $request_quantity = 0;
            }
        }
    }



    public function saveMaterialIssue($product_history, $store)
    {

        $prefix = $this->getPrefix($product_history->document_no);

        $setoff_mi = new ProductHistorySetoff();
        $setoff_mi->document_no = $product_history->document_no;
        $setoff_mi->internal_id = $product_history->internal_id;
        $setoff_mi->external_id = $prefix . "" . $product_history->external_id;
        $setoff_mi->ref_internal_id = $product_history->internal_id;
        $setoff_mi->ref_external_id = $product_history->external_id;
        $setoff_mi->ref_document_no = $product_history->document_no;
        $setoff_mi->quantity = $product_history->quantity;
        $setoff_mi->setoff_quantity = 0;
        $setoff_mi->cost_price = 0;
        $setoff_mi->grn_internal_id = $product_history->internal_id;
        $setoff_mi->grn_external_id = $product_history->external_id;
        $setoff_mi->product_history_transaction_id = $product_history->transaction_id;
        $setoff_mi->product_id = $product_history->product_id;
        $setoff_mi->store_id = $store;
        $setoff_mi->user_id = $product_history->user_id;
        if ($setoff_mi->save()) {
            $this->setoffMaterialIssue($setoff_mi);
        }
    }





    private function setoffMaterialIssue($setoff_mi)
    {
        
        $product_history_setoff =  ProductHistorySetoff::where([['product_id', '=', $setoff_mi->product_id], ['store_id', '=', $setoff_mi->store_id]])->get();
        $request_quantity = 0;
        foreach ($product_history_setoff as $setoff) {

            $available_quantity = $setoff->quantity - $setoff->setoff_quantity;
            if ($available_quantity > 0 && $request_quantity == 0) {

                $setoff_quantity = ($available_quantity - abs($setoff_mi->quantity));
                if ($setoff_quantity > 0) {
                    $this->setoff($setoff->transaction_id, $setoff_mi->transaction_id, $setoff_mi->quantity);
                    break;
                } else {
                    $this->setoff($setoff->transaction_id, $setoff_mi->transaction_id, $available_quantity);
                    $request_quantity = (abs($setoff_mi->quantity) -  abs($available_quantity));
                }
            } else {
                $this->setoff($setoff->transaction_id, $setoff_mi->transaction_id, $request_quantity);
                $request_quantity = 0;
            }
        }
    }


    private function setoff($history_setoff_transaction_id, $setoff_transaction_id, $setoff_quantity)
    {
        $history_setoff = ProductHistorySetoff::find($history_setoff_transaction_id);
        if ($history_setoff) {
            $history_setoff->setoff_quantity += abs($setoff_quantity);
            if ($history_setoff->update()) {
                $setoff = ProductHistorySetoff::find($setoff_transaction_id);
                if ($setoff) {
                    $setoff->ref_internal_id = $history_setoff->internal_id;
                    $setoff->ref_external_id = $history_setoff->external_id;
                    $setoff->ref_document_no = $history_setoff->document_no;
                    $setoff->grn_internal_id = $history_setoff->grn_internal_id;
                    $setoff->grn_external_id = $history_setoff->grn_external_id;
                    $setoff->update();
                }
            }
        }
    }



    private function getPrefix($document_no)
    {
        $document_no = DocumentNumber::where('document_number', '=', $document_no)->first();
        $prefix = "";
        if ($document_no) {
            $prefix = $document_no->prefix;
        }

        return $prefix;
    }


}
